﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Documents.Excel;
using System.IO;

namespace ExcelBgThread
{
  public partial class MainPage : UserControl
  {
    public MainPage()
    {
      InitializeComponent();
    }

    private void button1_Click(object sender, RoutedEventArgs e)
    {
      button1.IsEnabled = false;

      SaveFileDialog dialog = new SaveFileDialog { Filter = "Excel file|*.xls", DefaultExt = "xls" };

      if (dialog.ShowDialog() == true)
      {
        Stream stream = dialog.OpenFile();

        BackgroundWorker bg = new BackgroundWorker();
        bg.DoWork += new DoWorkEventHandler(bg_DoWork);
        bg.RunWorkerCompleted += new RunWorkerCompletedEventHandler(bg_RunWorkerCompleted);
        bg.RunWorkerAsync(stream);
      }
    }

    void bg_DoWork(object sender, DoWorkEventArgs e)
    {
      Workbook workbook = new Workbook();
      Worksheet worksheet = workbook.Worksheets.Add("test");

      worksheet.Rows[0].Cells[0].CellFormat.FillPatternForegroundColor = Colors.Cyan;

      workbook.Save((Stream)e.Argument);
      e.Result = e.Argument;
    }

    void bg_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
    {
      ((Stream)e.Result).Dispose();
    }

  }
}
